-- Settings

defaultclawendurance = 20	-- Hits needed to break cuffs.
only_once = true			-- Handcuffs only once, then must be acquired elsewhere to use again?
equiponspawn = true			-- Give cuffs to CT on spawn?
CTonCT = true				-- Can CT put cuffs on CT?
dir = "gfx/cuffs.png"		-- Directory for cuffs image.

-- Initialization

clawed = {}
images = {}
clawdamage = {}
for i = 1, game("sv_maxplayers") do images[i] = nil end
function initclawed() for i = 1, game("sv_maxplayers") do clawdamage[i] = defaultclawendurance clawed[i] = 0 end end
initclawed()

addhook("hit", "_hit")
addhook("leave", "_leave")
if equiponspawn then addhook("spawn", "_spawn") end
addhook("endround", "_endround")
addhook("select", "_select")
addhook("die", "_die")
addhook("drop", "_drop")
addhook("second", "_second")
addhook("walkover", "_walkover")
addhook("attack", "_attack")
addhook("attack2", "_attack")

-- Main Code

function _attack(p)
	if clawed[p] == 1 then
		local rot = player(p, "rot")
		if rot < -90 then rot = rot + 360 end
		local angle = math.rad(math.abs(rot +90)) - math.pi
		local x = player(p,"tilex") + math.cos(angle) * 1
		local y = player(p,"tiley") + math.sin(angle) * 1
		if tile(x, y, "property") >= 1 and tile(x, y, "property") <= 4 then
			if clawdamage[p] > 0 then clawdamage[p] = clawdamage[p] - 1
			else clawed[p] = 0 if images[p] ~= nil then freeimage(images[p]) images[p] = nil end parse("strip "..p.." 78") end
		end
	end
end

function _walkover(p)
	if clawed[p] == 1 then return 1 end
end

function _second()
	for i = 1, #clawed do
		if clawed[i] == 1 then parse("setweapon "..i.." 78") end
	end
end

function _drop(p, n, i)
	if clawed[p] == 1 then return 1 end
end

function _die(p)
	if clawed[p] == 1 then
		parse("strip "..p.." 78")
		clawed[p] = 0
		if images[p] ~= nil then freeimage(images[p]) images[p] = nil end
		clawdamage[p] = defaultclawendurance
	end
end

if equiponspawn then function _spawn(p)
	if player(p, "team") == 2 then return 78 end
end
end

function _hit(v, p, w)
	if clawed[p] == 1 then return 1 end
	if w == 78 then
		if clawed[v] == 0 and ((player(p, "team") == 2 and player(v, "team") == 2) == false or CTonCT) then -- cuff
			clawed[v] = 1
			clawdamage[v] = defaultclawendurance
			images[v] = image(dir, 2, -1, v+200)
			parse("equip "..v.." 78")
			parse("setweapon "..v.." 78")
			if only_once then parse("strip "..p.." 78") end
		elseif clawed[v] == 1 then -- uncuff
			clawed[v] = 0
			if images[v] ~= nil then freeimage(images[v]) images[v] = nil end
			parse("strip "..v.." 78")
		end
		return 1
	end
end

function _leave(p)
	clawed[p] = 0
	if images[p] ~= nil then freeimage(images[p]) images[p] = nil end
	clawdamage[p] = defaultclawendurance
end

function _select(p)
	if clawed[p] == 1 then parse("setweapon "..p.." 78") end
end

function _endround()
	initclawed()
end